# coingecko-openapi-client
No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 3.0.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.languages.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import coingecko_openapi_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import coingecko_openapi_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import coingecko_openapi_client
from coingecko_openapi_client.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = coingecko_openapi_client.AssetPlatformsApi(coingecko_openapi_client.ApiClient(configuration))
filter = 'filter_example' # str | apply relevant filters to results  valid values: \"nft\" (asset_platform nft-support) (optional)

try:
    # List all asset platforms (Blockchain networks)
    api_instance.asset_platforms_get(filter=filter)
except ApiException as e:
    print("Exception when calling AssetPlatformsApi->asset_platforms_get: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://api.coingecko.com/api/v3*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AssetPlatformsApi* | [**asset_platforms_get**](docs/AssetPlatformsApi.md#asset_platforms_get) | **GET** /asset_platforms | List all asset platforms (Blockchain networks)
*CategoriesApi* | [**coins_categories_get**](docs/CategoriesApi.md#coins_categories_get) | **GET** /coins/categories | List all categories with market data
*CategoriesApi* | [**coins_categories_list_get**](docs/CategoriesApi.md#coins_categories_list_get) | **GET** /coins/categories/list | List all categories
*CoinsApi* | [**coins_id_get**](docs/CoinsApi.md#coins_id_get) | **GET** /coins/{id} | Get current data (name, price, market, ... including exchange tickers) for a coin
*CoinsApi* | [**coins_id_history_get**](docs/CoinsApi.md#coins_id_history_get) | **GET** /coins/{id}/history | Get historical data (price, market cap, 24hr volume, ..) at a given date for a coin.
*CoinsApi* | [**coins_id_market_chart_get**](docs/CoinsApi.md#coins_id_market_chart_get) | **GET** /coins/{id}/market_chart | Get historical market data include price, market cap, and 24h volume (granularity auto)
*CoinsApi* | [**coins_id_market_chart_range_get**](docs/CoinsApi.md#coins_id_market_chart_range_get) | **GET** /coins/{id}/market_chart/range | Get historical market data include price, market cap, and 24h volume within a range of timestamp (granularity auto)
*CoinsApi* | [**coins_id_ohlc_get**](docs/CoinsApi.md#coins_id_ohlc_get) | **GET** /coins/{id}/ohlc | Get coin&#39;s OHLC
*CoinsApi* | [**coins_id_tickers_get**](docs/CoinsApi.md#coins_id_tickers_get) | **GET** /coins/{id}/tickers | Get coin tickers (paginated to 100 items)
*CoinsApi* | [**coins_list_get**](docs/CoinsApi.md#coins_list_get) | **GET** /coins/list | List all supported coins id, name and symbol (no pagination required)
*CoinsApi* | [**coins_markets_get**](docs/CoinsApi.md#coins_markets_get) | **GET** /coins/markets | List all supported coins price, market cap, volume, and market related data
*CompaniesBetaApi* | [**companies_public_treasury_coin_id_get**](docs/CompaniesBetaApi.md#companies_public_treasury_coin_id_get) | **GET** /companies/public_treasury/{coin_id} | Get public companies data
*ContractApi* | [**coins_id_contract_contract_address_get**](docs/ContractApi.md#coins_id_contract_contract_address_get) | **GET** /coins/{id}/contract/{contract_address} | Get coin info from contract address
*ContractApi* | [**coins_id_contract_contract_address_market_chart_get**](docs/ContractApi.md#coins_id_contract_contract_address_market_chart_get) | **GET** /coins/{id}/contract/{contract_address}/market_chart/ | Get historical market data include price, market cap, and 24h volume (granularity auto) from a contract address 
*ContractApi* | [**coins_id_contract_contract_address_market_chart_range_get**](docs/ContractApi.md#coins_id_contract_contract_address_market_chart_range_get) | **GET** /coins/{id}/contract/{contract_address}/market_chart/range | Get historical market data include price, market cap, and 24h volume within a range of timestamp (granularity auto) from a contract address
*DerivativesApi* | [**derivatives_exchanges_get**](docs/DerivativesApi.md#derivatives_exchanges_get) | **GET** /derivatives/exchanges | List all derivative exchanges
*DerivativesApi* | [**derivatives_exchanges_id_get**](docs/DerivativesApi.md#derivatives_exchanges_id_get) | **GET** /derivatives/exchanges/{id} | show derivative exchange data
*DerivativesApi* | [**derivatives_exchanges_list_get**](docs/DerivativesApi.md#derivatives_exchanges_list_get) | **GET** /derivatives/exchanges/list | List all derivative exchanges name and identifier
*DerivativesApi* | [**derivatives_get**](docs/DerivativesApi.md#derivatives_get) | **GET** /derivatives | List all derivative tickers
*ExchangeRatesApi* | [**exchange_rates_get**](docs/ExchangeRatesApi.md#exchange_rates_get) | **GET** /exchange_rates | Get BTC-to-Currency exchange rates
*ExchangesApi* | [**exchanges_get**](docs/ExchangesApi.md#exchanges_get) | **GET** /exchanges | List all exchanges (Active with trading volumes)
*ExchangesApi* | [**exchanges_id_get**](docs/ExchangesApi.md#exchanges_id_get) | **GET** /exchanges/{id} | Get exchange volume in BTC and top 100 tickers only
*ExchangesApi* | [**exchanges_id_tickers_get**](docs/ExchangesApi.md#exchanges_id_tickers_get) | **GET** /exchanges/{id}/tickers | Get exchange tickers (paginated, 100 tickers per page)
*ExchangesApi* | [**exchanges_id_volume_chart_get**](docs/ExchangesApi.md#exchanges_id_volume_chart_get) | **GET** /exchanges/{id}/volume_chart | Get 24 hour rolling trading volume data (in BTC) for a given exchange.
*ExchangesApi* | [**exchanges_list_get**](docs/ExchangesApi.md#exchanges_list_get) | **GET** /exchanges/list | List all supported markets id and name (no pagination required)
*GlobalApi* | [**global_decentralized_finance_defi_get**](docs/GlobalApi.md#global_decentralized_finance_defi_get) | **GET** /global/decentralized_finance_defi | Get cryptocurrency global decentralized finance(defi) data
*GlobalApi* | [**global_get**](docs/GlobalApi.md#global_get) | **GET** /global | Get cryptocurrency global data
*NftsBetaApi* | [**nfts_asset_platform_id_contract_contract_address_get**](docs/NftsBetaApi.md#nfts_asset_platform_id_contract_contract_address_get) | **GET** /nfts/{asset_platform_id}/contract/{contract_address} | Get current data (name, price_floor, volume_24h ...) for an NFT collection.
*NftsBetaApi* | [**nfts_id_get**](docs/NftsBetaApi.md#nfts_id_get) | **GET** /nfts/{id} | Get current data (name, price_floor, volume_24h ...) for an NFT collection
*NftsBetaApi* | [**nfts_list_get**](docs/NftsBetaApi.md#nfts_list_get) | **GET** /nfts/list | List all supported NFT ids, paginated by 100 items per page, paginated to 100 items
*PingApi* | [**ping_get**](docs/PingApi.md#ping_get) | **GET** /ping | Check API server status
*SearchApi* | [**search_get**](docs/SearchApi.md#search_get) | **GET** /search | Search for coins, categories and markets on CoinGecko
*SimpleApi* | [**simple_price_get**](docs/SimpleApi.md#simple_price_get) | **GET** /simple/price | Get the current price of any cryptocurrencies in any other supported currencies that you need.
*SimpleApi* | [**simple_supported_vs_currencies_get**](docs/SimpleApi.md#simple_supported_vs_currencies_get) | **GET** /simple/supported_vs_currencies | Get list of supported_vs_currencies.
*SimpleApi* | [**simple_token_price_id_get**](docs/SimpleApi.md#simple_token_price_id_get) | **GET** /simple/token_price/{id} | Get current price of tokens (using contract addresses) for a given platform in any other currency that you need.
*TrendingApi* | [**search_trending_get**](docs/TrendingApi.md#search_trending_get) | **GET** /search/trending | Get trending search coins (Top-7) on CoinGecko in the last 24 hours


## Documentation For Models



## Documentation For Authorization

 All endpoints do not require authorization.


## Author



